



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#可扩展编程之MEF学习笔记（一）：MEF简介及简单的Demo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#可扩展编程之MEF学习笔记（一）：MEF简介及简单的Demo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 22:14:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在文章开始之前，首先简单介绍一下什么是MEF，MEF,全称Managed Extensibility Framework（托管可扩展框架）。单从名字我们不难发现：MEF是专门致力于解决扩展性问题的框架，MSDN中对MEF有这样一段说明：</p>
<p>　　Managed Extensibility Framework 或 MEF 是一个用于创建可扩展的轻型应用程序的库。 应用程序开发人员可利用该库发现并使用扩展，而无需进行配置。 扩展开发人员还可以利用该库轻松地封装代码，避免生成脆弱的硬依赖项。 通过 MEF，不仅可以在应用程序内重用扩展，还可以在应用程序之间重用扩展。</p>
<p>　　废话不多说了，想了解更多关于MEF的内容，到百度上面查吧！</p>
<p>　　MEF的使用范围广泛，在Winform、WPF、Win32、Silverlight中都可以使用，我们就从控制台说起，看看控制台下如何实现MEF，下面先新建一个win32控制台项目MEFDemo，添加一个IBookService接口，写一个简单的Demo:</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/622439/201408/191658197213978.png" /></p>
<p>IBookService内容如下：</p>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;

namespace MEFDemo<br />
{<br />
   public interface IBookService<br />
   {<br />
      string BookName { get; set; }<br />
      string GetBookName();<br />
   }<br />
}</pre>
</div>
<p>下面添加对System.ComponentModel.Composition命名空间的引用，由于在控制台程序中没有引用这个DLL，所以要手动添加：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/622439/201408/191701505186777.png" /></p>
<p>点击OK，完成添加引用，新建一个Class，如：MusicBook继承IBookService接口,代码如下：</p>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.ComponentModel.Composition;

namespace MEFDemo<br />
{<br />
   [Export(typeof(IBookService))]<br />
   public class MusicBook : IBookService<br />
   {<br />
      public string BookName { get; set; }

      public string GetBookName()<br />
      {<br />
         return "MusicBook";<br />
      }<br />
   }<br />
}</pre>
</div>
<p>Export(typeof(IBookService)) 这句话将类声明导出为IBookService接口类型。</p>
<p>然后修改Porgram中的代码如下：</p>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Reflection;<br />
using System.ComponentModel.Composition;<br />
using System.ComponentModel.Composition.Hosting;

namespace MEFDemo<br />
{<br />
   class Program<br />
   {<br />
      [Import]<br />
      public IBookService Service { get; set; }

      static void Main(string[] args)<br />
      {<br />
         Program pro = new Program();<br />
         pro.Compose();<br />
         if (pro.Service != null)<br />
         {<br />
            Console.WriteLine(pro.Service.GetBookName());<br />
         }<br />
         Console.Read();<br />
      }

      private void Compose()<br />
      {<br />
         var catalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());<br />
         CompositionContainer container = new CompositionContainer(catalog);<br />
         container.ComposeParts(this);<br />
      }<br />
   }<br />
}</pre>
</div>
<p>这里使用[Import]导入刚刚导出的MusicBook，下面的Compose方法，实例化CompositionContainer来实现组合，点击F5运行，结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/622439/201408/191725037994399.png" /></p>
<p>可以看到调用了MusicBook类的GetBookName方法，但是我们并没有实例化MusicBook类，是不是很神奇呢？？？</p>
<p>这一就是实现了主程序和类之间的解耦，大大提高了代码的扩展性和易维护性！</p>
<p>MEF系列文章：</p>
<p><a href="http://www.cnblogs.com/yunfeifei/p/3922668.html" rel="external nofollow noreferrer">C#可扩展编程之MEF学习笔记（一）：MEF简介及简单的Demo</a></p>
<p><a href="http://www.cnblogs.com/yunfeifei/p/3922891.html" rel="external nofollow noreferrer">C#可扩展编程之MEF学习笔记（二）：MEF的导出(Export)和导入(Import)</a></p>
<p><a href="http://www.cnblogs.com/yunfeifei/p/3927663.html" rel="external nofollow noreferrer">C#可扩展编程之MEF学习笔记（三）：导出类的方法和属性</a></p>
<p><a href="http://www.cnblogs.com/yunfeifei/p/3940075.html" rel="external nofollow noreferrer">C#可扩展编程之MEF学习笔记(四)：见证奇迹的时刻</a></p>
<p><a href="http://www.cnblogs.com/yunfeifei/p/3991330.html" rel="external nofollow noreferrer">C#可扩展编程之MEF学习笔记(五)：MEF高级进阶</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2gm2v8.html">SVN强制解锁操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq46vx58.html">Yeo 17-ROI parcellation</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2nx6oq.html">清北学堂模拟day6 圆桌游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96n41nq.html">iOS&comma;Xcod7&sol;8&comma;iOS使用修改点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1wwe9.html">P1119 灾后重建</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xgzmz8.html">最大熵的Java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1l06g8.html">轮子来袭 vJine&period;Core Orm 之 02&lowbar;代码生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mj42eq.html">ASP&period;NET MVC 3 Razor Views in SharePoint</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jze04g8.html">css样式表及属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoj5ynq.html">最近公共祖先LCA&lpar;Tarjan算法&rpar;的思考和算法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ko1v29.html">CentOS 7 源码编译安装MySQL 5&period;7&period;14</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj1k749.html">ReactJS之遍历对象的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603lvj9.html">JAVA API的下载和中文查看API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwk6m09.html">Redhat中关于httpd仓库安装的简要步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6rwe9.html">超级简单的数据压缩算法&mdash;LZW算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxnw09.html">查看和指定SpringBoot内嵌Tomcat的版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxxgd9.html">MySQLi面向对象实践--multi&lowbar;query</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjp5mzq.html">Delphi XE2 compiler performance</a>
		</li>
						<li><a href="https://www.batexi.com/a/9633m349.html">迭代器模式和组合模式（head first设计模式&mdash;&mdash;8）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql115p19.html">spring websocket &plus; stomp 实现广播通信和一对一通信&amp;lt&semi;转&amp;gt&semi;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdgp00q.html">Keras Installation</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2g5eo8.html">Xilinx的约束文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/495zmge9.html">myeclipse2014激活</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gz4308.html">UVa 11729</a>
			</li>
						<li><a href="https://www.batexi.com/a/495zmym9.html">java：关于继承变量的值问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/495zw3e9.html">经验总结之Android framework开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mykr28.html">成都印迹婚纱摄影 &vert; yinjilove&period;com</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq477yeq.html">IOS竖屏应用单个页面横屏的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlwppk8.html">【原创】JAVA并发编程&mdash;&mdash;Callable和Future源码初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kkdw38.html">JS实现雪花效果</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
